<?php // vim:syntax=php
/*
	The Malete project - the Z39.2/Z39.50 database framework of OpenIsis.
	Version 0.9.x (patchlevel see file Version)
	Copyright (C) 2001-2004 by Erik Grziwotz, erik@openisis.org

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	see README for more information
EOH */

// $Id: unicode.php,v 1.3 2004/11/12 09:35:17 kripke Exp $
// unicode demo for the Isis package

/*
NOTE: this file contains offending literal UTF-8 data
If you see more than one character between these >ß< angle brackets, then:
-	use an UTF-8 capable xterm like
LC_CTYPE=en_US.UTF-8 LESSCHARSET=UTF-8 \
	xterm -u8 -fn -misc-fixed-medium-r-normal--15-140-75-75-c-90-iso10646-1
-	use an UTF-8 capable editor like
vim '+set encoding=utf-8' unicode.php

moreover this file contains some german:
	stadt=city land=country fluss=river bitte=please suchen=search
*/

header("Content-type: text/html; charset=UTF-8");

require 'Isis.php'; // use require 'Isis/Rec.php' if you need only this
?><html><head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>Unicode-Demo for package Isis</title>
</head><body>
<?php
	
	// create a db with field list ("fdt")
	$fdt = array(
		'bitte' => 10, 
		'nach'  => 11, 
		'mfn'  => 12, 
		'stadt' => 21,
		'land'  => 22,
		'fluss' => 23
	);

	// get request parameters a and b
	// (as well as any plain numeric and v%d style
	$db = new Isis_Db($fdt, 'unicode', new Isis_Server());
	if ( !$db->srv->sock ) {
		echo "could not contact server</body></html>\n";
		exit;
	}
	// $db->srv->dbg = true;
	$param = Isis_Http::fromReq($db);
	$paramdump = $param->toString();

	$bitte = $param->v('bitte');
	$param->del('bitte');
	$nach = $param->v('nach');
	if ('\"' == substr($nach,0,2)) // grrr ... stupid magic_quotes_gpc
		$nach = stripslashes($nach);
	$param->del('nach');
	$mfn = $param->v('mfn');
	$param->del('mfn');
	// if ('bearbeiten' == $bitte) { $param = $db->read($mfn); }
?>
<img src="http://openisis.org/img/logo.gif" alt="Isi"
	width="100" height="100" align="left" hspace="25" border="0"/>
<form action="/php/unicode" method="POST">
	Stadt <input type="text" name="stadt" value="<?=$param->h('stadt')?>"/>
	Land <input type="text" name="land" value="<?=$param->h('land')?>"/>
	Fluß <input type="text" name="fluss" value="<?=$param->h('fluss')?>"/>
	<input type="submit" name="bitte" value="speichern"/>
</form>
<br/>
<form action="/php/unicode">
	nach <input type="text" name="nach" value="<?=htmlspecialchars($nach)?>"/>
	<input type="submit" name="bitte" value="suchen"/>
	<input type="submit" name="bitte" value="terms"/>
alle
<a href="/php/unicode?bitte=suchen">suchen</a>
<a href="/php/unicode?bitte=terms">terms</a>
</form>
<br/>
<?php
	switch ($bitte) {
	case 'speichern':
		$mfns = $db->write($param);
		echo "wrote ",count($mfns), " mfns: ", join(',',$mfns),"</br>\n";
		$idx = new Isis_Rec();
		$idx->head = 's';
		$idx->set($fdt['stadt'], $param->v('stadt'));
		$idx->set($fdt['land'], $param->v('land'));
		$idx->set($fdt['fluss'], $param->v('fluss'));
		// echo "<pre>---\n", $idx->toString(), "---\n</pre>\n";
		$res = $db->index($idx);
		echo "got $res</br>\n";
		break;
	case 'suchen':
		if (!$nach)
			$nach = '""$';
		$recs = $db->query($nach);
?>
<table cols=4 width="100%">
<tr bgcolor="#CCCCCC">
	<th width="7%">Mfn</th>
	<th>Stadt</th>
	<th>Land</th>
	<th>Fluß</th>
	</tr>
<?php
		foreach ($recs as $r) {
			echo "<tr>\n";
			list($mfn,) = split("@",$r->head);
			printf("<td>%s</td>\n", $mfn);
			printf("<td>%s</td>\n", $r->h('stadt'));
			printf("<td>%s</td>\n", $r->h('land'));
			printf("<td>%s</td>\n", $r->h('fluss'));
			echo "</tr>\n";
		}
		echo "</table>\n";
		break;
	case 'terms':
		$terms = $db->terms($nach);
		$nterms = count($terms);
		$percol = (int)(($nterms+4)/5);
?>
<table cols=5 width="100%">
<tr bgcolor="#CCCCCC"> <th colspan=5 align="center">
	<?=$nterms?> Indexeinträge</th></tr>
<tr valign="top"><td>
<?php
		$n = 0;
		foreach ($terms as $t) {
			$tab = strpos($t, "\t");
			$cnt = substr($t, 0, $tab);
			$term = substr($t, $tab+1); /* there may be tabs in term */
			printf(
				'<a href="/php/unicode?nach=%%22%s%%22&bitte=suchen">%s</a> (%d)'."<br/>\n",
				urlencode($term), $term, $cnt);
			if (!(++$n % $percol) && $nterms != $n) echo "</td><td>";
		}
		echo "</td></tr></table>\n";
		break;
	}
?>
<br/>
<table cols="4" width="100%">
<tr bgcolor="#CCCCCC">
	<th width="7%">Code</th>
	<th width="7%">&nbsp;</th>
	<th width="30%">Kategorie</th>
	<th>Name</th></tr>
<tr><td colspan="2"></td><td colspan="2">aus
	<a href="http://www.alanwood.net/unicode/latin_1_supplement.html">
	Latin-1 Supplement 0080-00FF</a></td></tr>
<tr><td>00D6</td><td>'Ö'</td>
	<td>LATIN CAPITAL LETTER</td><td>O WITH DIAERESIS (Ouml)</td></tr>
<tr><td>00F1</td><td>'ñ'</td>
	<td valign="top" rowspan=4>LATIN SMALL LETTER</td><td>N WITH TILDE (ntilde)</td></tr>
<tr><td>00F3</td><td>'ó'</td><td>O WITH ACUTE (oacute)</td></tr>
<tr><td>00F6</td><td>'ö'</td><td>O WITH DIAERESIS (ouml)</td></tr>
<tr><td>00FC</td><td>'ü'</td><td>U WITH DIAERESIS (uuml)</td></tr>

<tr><td colspan="2"></td><td colspan="2">aus
	<a href="http://www.alanwood.net/unicode/latin_extended_a.html">
	Latin Extended-A 0100-017F</a></td></tr>
<tr><td>010C</td><td>'Č'</td>
	<td valign="top" rowspan=2>LATIN CAPITAL LETTER</td><td>C WITH CARON</td></tr>
<tr><td>0141</td><td>'Ł'</td><td>L WITH STROKE</td></tr>
<tr><td>0142</td><td>'ł'</td>
	<td valign="top" rowspan=2>LATIN SMALL LETTER</td><td>L WITH STROKE</td></tr>
<tr><td>017A</td><td>'ź'</td><td>Z WITH ACUTE</td></tr>

<tr><td colspan="2"></td><td colspan="2">aus
	<a href="http://www.alanwood.net/unicode/ipa_extensions.html">
	IPA Extensions 0250-02AF</a></td></tr>
<tr><td>0283</td><td>'ʃ'</td>
	<td valign="top" rowspan=3>LATIN SMALL LETTER</td><td>ESH</td></tr>
<tr><td>028C</td><td>'ʌ'</td><td>TURNED V</td></tr>
<tr><td>02A8</td><td>'ʨ'</td><td>TC DIGRAPH WITH CURL</td></tr>

<tr><td colspan="2"></td><td colspan="2">aus
	<a href="http://www.alanwood.net/unicode/greek.html">
	Greek and Coptic 0370-03FF</a></td></tr>
<tr><td>0391</td><td>'Α'</td>
	<td valign="top" rowspan=2>GREEK CAPITAL LETTER</td><td>ALPHA (Alpha)</td></tr>
<tr><td>0395</td><td>'Ε'</td><td>EPSILON (Epsilon)</td></tr>
<tr><td>03AC</td><td>'ά'</td>
	<td valign="top" rowspan=7>GREEK SMALL LETTER</td><td>ALPHA WITH TONOS</td></tr>
<tr><td>03AE</td><td>'ή'</td><td>ETA WITH TONOS</td></tr>
<tr><td>03B1</td><td>'α'</td><td>ALPHA (alpha)</td></tr>
<tr><td>03B4</td><td>'δ'</td><td>DELTA (delta)</td></tr>
<tr><td>03B8</td><td>'θ'</td><td>THETA (theta)</td></tr>
<tr><td>03BB</td><td>'λ'</td><td>LAMDA (lambda)</td></tr>
<tr><td>03BD</td><td>'ν'</td><td>NU (nu)</td></tr>

<tr><td colspan="2"></td><td colspan="2">aus
	<a href="http://www.alanwood.net/unicode/cyrillic.html">
	Cyrillic 0400-04FF</a></td></tr>
<tr><td>041C</td><td>'М'</td>
	<td valign="top" rowspan=2>CYRILLIC CAPITAL LETTER</td><td>EM</td></tr>
<tr><td>0420</td><td>'Р'</td><td>ER</td></tr>
<tr><td>0430</td><td>'а'</td>
	<td valign="top" rowspan=7>CYRILLIC SMALL LETTER</td><td>A</td></tr>
<tr><td>0432</td><td>'в'</td><td>VE</td></tr>
<tr><td>0438</td><td>'и'</td><td>I</td></tr>
<tr><td>043A</td><td>'к'</td><td>KA</td></tr>
<tr><td>043E</td><td>'о'</td><td>O</td></tr>
<tr><td>0441</td><td>'с'</td><td>ES</td></tr>
<tr><td>044F</td><td>'я'</td><td>YA</td></tr>
</table>
<?php
	// phpinfo();
/*
	function printrange ($name, $beg, $end, $aw)
	{
		printf("**** %s %04X-%04X ", $name, $beg, $end);
		printf('<a href="http://www.alanwood.net/unicode/%s.html">html</a> ', $aw);
		printf('<a href="http://www.unicode.org/charts/PDF/U%04X.pdf">pdf</a>', $beg);
		printf("<br/>\n");

		for (; $beg < $end; ) {
			$line = sprintf("%04X", $beg);
			for ($i=16; $i--; $beg++)
				$line .= sprintf(" %c%c", 192+($beg>>6), 128+(63&$beg));
			printf("%s<br/>\n", $line);
		}
	}
	// c.f. http://openisis.org/Doc/UniStat
	// http://www.alanwood.net/unicode/#links
	printrange('Latin-1 Supplement', 0x0080, 0x00FF, 'latin_1_supplement');
	printrange('Latin Extended-A', 0x0100, 0x017F, 'latin_extended_a');
	printrange('Latin Extended-B', 0x0180, 0x024F, 'latin_extended_b');
	printrange('IPA Extensions', 0x0250, 0x02AF, 'ipa_extensions');
	printrange('Greek and Coptic', 0x0370, 0x03FF, 'greek');
	printrange('Cyrillic', 0x0400, 0x04FF, 'cyrillic');

<br/>
Parameters:
<pre>--
<?=htmlspecialchars($paramdump)?>--</pre>
*/
?>
</body></html>
